% Lezione di lab. 3 TTR  -05/12/2012- Tracking by Condensation- Marco Cristani

clear all;
clc;

%----------------------
% INIZIALIZZAZIONI
%----------------------

N       = 50 ; % numero particelle;
n_it    = 20   ; % iterazioni (= frames) del tracking;
loc_w   = 2   ; % larghezza della finestra d'osservazione;
dvst    = loc_w/3; % dev. standard per l'osservazione;

%% -- PARAMETRI MOTO -- %%
step        = 0.4  ;   
p_noise     = 0.075 ;  


%% -- PARAMETRI MODELLO DINAMICO -- %%
diffu = 2; 
%% -- PRIMO SAMPLING -- %%
real_pos               = 0.0;

for n=1:N
   s_old(n)                 =  unifrnd(real_pos-3,real_pos+3) ;
end;  
pi = ones(1,N)./N;
c = cumsum(pi);



 h = figure;
%----------------------
% CICLO PRINCIPALE
%----------------------
%% -- EVOLUZIONE SISTEMA -- %%
for i=1:n_it
    real_pos    =   real_pos + step + p_noise * randn(1,1);
    x(i)        =   real_pos;
    fprintf('t=%i|true pos. %2.2f \n',i,x(i));
    sit(i).oneD =  [x(i),...
        unifrnd(real_pos-10,real_pos+10,1,round(unifrnd(1,5))),...
        normrnd(real_pos,0.01,1,3)];
%% -- ESTRAZIONE E APPLICAZIONE DINAMICA -- %%
 for n=1:N
      ind     = pick_base_sample(N,c);
      s(n)     = s_old(ind) + step + diffu * randn(1,1);
 end   

 scatter(i,real_pos,500,[1 0 0],'Marker','x');hold on 
 scatter(ones(1,size(sit(i).oneD,2)).*i,sit(i).oneD,10,[1 0 0],'Marker','o');
 
 %% -- VALUTAZIONE DELL'OSSERVAZIONE -- %%
 for n=1:N
     mpi(n) = 0;
     for j =1:size(sit(i).oneD,2)
         if s(n)+loc_w>sit(i).oneD(j) & s(n)-loc_w<sit(i).oneD(j)
            mpi(n)= mpi(n)+normpdf(sit(i).oneD(j),s(n),dvst);
         end
     end
 end   
 s_old = s;
 mpi = normalise(mpi);
 c = cumsum(mpi);
 
 scatter(ones(1,N).*i,s,'bo');%1000.*mpi+1);
 
 %% Determinazione della posizione del target stimata da Condensation
 % Media
 pos_mean(i)= s*mpi'/N;
 err_mean(i)= abs(x(i)-pos_mean(i));
 fprintf('Err media:%i \n',err_mean(i));
 % Max
 [thrash,max_ind]= max(mpi);
 pos_max(i)=s(max_ind);
 err_max(i)= abs(x(i)-pos_max(i));
  fprintf('Err MAP:%i \n',err_max(i));

 
 
 pause;
end



% Esercizi:
% 1) Stimate l'obiettivo individuato dal tracker ad ogni iterazione,
% mediante le due politiche viste a lezione. Visualizzate a schermo le
% stime ottenute. Calcolate l'errore (lineare) ottenuto.
% 2) Cambiate la dinamica della particella a piacere, osservate come
%    reagisce il tracker.
% In particolare:
    %a) dev standard del moto maggiore della dev standard del modello
    %b) step deterministico del movimento del target maggiore dello step
    %del modello dinamico ma dev. del modello maggiore
    %c) aumentare l'ampiezza della finestra d'osservazione
    
% 3) Aumentate/diminuite il numero delle particelle
% 4) Aumentate il numero delle presenze di rumore
% 5) Aggiungete un'altra particella con moto determinato
% 6) Modificate il codice, assumendo che il target sia colorato con una
% terna RGB




